/*
	CGI Source for Config.cpp

	Author	: Kang Jul Ki (Master 2nd)
	E-mail	: jkkang@sel.chonbuk.ac.kr
	Homepage: http://sel.chonbuk.ac.kr/~jkkang/
	Date	: August 21, 1997
	Class	: Software Engineering Lab.
		  Dept. of Electronic Engineering
		  Chonbuk National Univ.	

	Compiler: gcc 2.7.2
	Copyright (c) 1997, Kang Jul Ki & Software Engineering Lab
*/

#include "Config.h"
#include <ctype.h>

Config::Config()
{
	strcpy(m_szBaseDir, "");
	strcpy(m_szBbsDir, "");
	strcpy(m_szEmail, "");
	strcpy(m_szImageName, "");
	strcpy(m_szPassword, "");
	strcpy(m_szDbName, "");
}

Config::~Config()
{
}

int Config::EatWs(FILE *fpt)
{
	int	ch;

	while ((ch = fgetc(fpt)) != EOF)
	{
		if (ch != ' ' && ch != '\t')
		{
			return	ch;
		}
	}

	return	ch;
}

int Config::CfgGetLine(char *str, int n, FILE *fpt)
{
	int	iLen = 0, ch;

	ch = EatWs(fpt);

	while (1)
	{
		if (ch == EOF || ch == '\n' || (iLen == n-1))
		{
			if (iLen && str[iLen-1] == ' ')
				str[iLen-1] = '\0';
			else
				str[iLen] = '\0';
			return	feof(fpt) ? 1 : 0;
		}
		str[iLen++] = ch;
		ch = fgetc(fpt);
		if (ch == '\t' || ch == ' ')
		{
			str[iLen++] = ch;
			ch = EatWs(fpt);
		}
	}
}	

void Config::CfgGetWord(char *word, char *line)
{
	int	x = 0, y = 0;

	for (; line[x] && isspace(line[x]); x++);

	while (1)
	{
		if (!(word[y] = line[x]))
			break;
		if (isspace(line[x]))
			if ((!x) || (line[x-1] != '\\'))
				break;
		if (line[x] != '\\')
			y++;
		x++;
	}

	word[y] = '\0';
	while (line[x] && isspace(line[x])) x++;
	for (y=0; (line[y] = line[x]); x++, y++);
}

char* Config::ItoA(int iNum, char *str)
{
	sprintf(str, "%d", iNum);

	return	str;
}

stat Config::ProcessConfig(void)
{
	int	i = 0;
	FILE	*fp;

	char	l[MAX_STRING_LEN] = "";
	char	w[MAX_STRING_LEN] = "";
	char	w1[MAX_STRING_LEN] = "";
	char	w2[MAX_STRING_LEN] = "";
	char	str[MAX_STRING_LEN] = "";
	char	tmp[MAX_STRING_LEN] = "";

	/*
	** Open config file
	*/
	fp = fopen("GuestBook.conf", "r");

	if (fp == NULL)
	{
		printf("<font color=228b22 size=3>Can't open 'GuestBook.conf'!!!</font><br>%c", LF);
		return	ERR;
		exit(1);
	}

	/*
	** Parse config file. Remind me to learn yacc.
	*/
	while (!CfgGetLine(l, MAX_STRING_LEN, fp))
	{
		i++;

		if (l[0] != '#' && l[0] != '\0')
		{
			CfgGetWord(w, l);

			if (!strcmp(w, "BASE_DIR"))
			{
				strcpy(m_szBaseDir, l);
			}
			else if (!strcmp(w, "BBS_DIR"))
			{
				strcpy(tmp, l);
			}
			else if (!strcmp(w, "EMAIL"))
			{
				strcpy(m_szEmail, l);
			}
			else if (!strcmp(w, "Password"))
			{
				strcpy(m_szPassword, l);
			//	strcpy(m_szPassword, "white");	/* For security	*/
			}
			else if (!strcmp(w, (char *)ItoA(GetBoardNum(), str)))
			{
				CfgGetWord(w, l);		/* guest.gif	*/
				CfgGetWord(w1, l);		/* Email	*/
				CfgGetWord(w2, l);		/* DB Name	*/
				strcpy(m_szImageName, w);
				sprintf(m_szBbsDir, "%s%d%s", tmp, GetBoardNum(), "/");
				if (strcmp(w1, ""))
					strcpy(m_szEmail, w1);	/* Email	*/
				strcpy(m_szDbName, w2);
			}
		}
	}

	fclose(fp);

#ifdef _DEBUG_
	printf("BASE_DIR : %s%c<br>", m_pConfig->GetBaseDir(), LF);
	printf("BBS_DIR  : %s%c<br>", m_pConfig->GetBbsDir(), LF);
	printf("ERASE_DOMAIN : %s%c<br>", m_pConfig->GetEraseDomain(), LF);
	printf("EMAIL    : %s%c<br>", m_pConfig->GetEmail(), LF);
	printf("Image	 : %s%c<br>", m_pConfig->GetImageFile(), LF);
#endif

	return	OK;
}
