/*
	MeetBoard.cpp

	Author	: Kang Jul Ki (Master 2nd)
	E-mail	: jkkang@sel.chonbuk.ac.kr
	Homepage: http://sel.chonbuk.ac.kr/~jkkang/
	Date	: August 21, 1997
	Class	: Software Engineering Lab.
		  Dept. of Electronic Engineering
		  Chonbuk National Univ.	

	Compiler: gcc 2.7.2
	Copyright (c) 1997, Kang Jul Ki & Software Engineering Lab
*/

#include "MeetBoard.h"
#include <stdlib.h>

MeetBoard::MeetBoard()
{
	m_pDB		= new DB;
	m_pmSQL		= new mSQL;
	m_pConfig	= new Config;
	m_pParam	= new CGI_ENTRY;
}

MeetBoard::~MeetBoard()
{
	delete	m_pDB;
	delete	m_pmSQL;
	delete	m_pConfig;
	delete	m_pParam;
}

void MeetBoard::ShowMimeType()
{
	printf("Content-type: text/html%c%c", LF, LF);
}

void MeetBoard::GetEnv()
{
	/*
	** Get environment variable from HTTP
	*/
	m_pBuf = getenv("QUERY_STRING");

	for (int i=0; i<2; i++)
	{
		(m_pParam+i)->f_val  = (char *)makeword(m_pBuf, '&');
		(m_pParam+i)->f_name = (char *)makeword((m_pParam+i)->f_val, '=');
	}

	m_pConfig->m_iBoardNum = atoi((m_pParam+0)->f_val);
	m_pConfig->m_iTextNum  = atoi((m_pParam+1)->f_val);
	m_iIndex = m_pConfig->m_iTextNum;

	m_pConfig->ProcessConfig();
}

void MeetBoard::ShowBoard()
{
	char	szQuery[MAX_QUERY];
	int	ret, iCount = 1, iPrev, i=0, j = 1;
	int	iNum;

	iPrev = m_iIndex - 10;
	if (iPrev < 0)	iPrev = 0;

	m_pmSQL->mSQLConnect(m_pConfig->GetDbName());
	m_pmSQL->mSQLSelectDB();

	sprintf(szQuery, "select * from %s order by id DESC", m_pConfig->GetDbName());
	m_pmSQL->mSQLSetQuery(szQuery);
	m_pmSQL->mSQLQuery();
	m_pmSQL->mSQLStoreResult();
	m_pmSQL->mSQLNumRows();
	
	iNum = m_pmSQL->mSQLGetNumRow() - m_iIndex; 

	printf("<html>%c", LF);
	printf("<head><title>Խ  2.3</title></head>%c", LF);
	printf("<body bgcolor=ffffff>%c", LF);

	printf("<center>%c", LF);
	printf("<img src=%sImage/%s border=0>%c", m_pConfig->GetBaseDir(), m_pConfig->GetImageName(), LF);

	printf("<table border=0 cellspace=3>%c", LF);
		printf("<tr>%c", LF);
			printf("<td valign=buttom>%c", LF);
			printf("<img align=left border=0 src=%sImage/bookpen.gif>%c", m_pConfig->GetBaseDir(), LF);

			printf("<br>%c", LF);
			printf("<img width=480 src=%sImage/line_ani.gif>%c", m_pConfig->GetBaseDir(), LF);
			printf("</td>%c", LF);
		printf("</tr>%c", LF);
	printf("</table>%c", LF);
	printf("</center>%c", LF);

	printf("<center>%c", LF);
	printf("<table border=0 align=center><tr><th><font size=-1>۹ȣ</font></th><th><font size=-1>۾</font></th><th><font size=-1>۾¥</font></th><th><font size=-1>Ƚ</font></th><th><font size=-1>ټ</font></th><th><font size=-1></font></th></tr>%c", LF);

	while((m_pmSQL->m_CurRow = msqlFetchRow(m_pmSQL->m_Result)) != NULL)
	{
		if (j > m_iIndex)		
		{
			printf("<tr>");
			printf("<td bgcolor=#f0f0e0 align=center><font size=-1>%d</font></td>", iNum);

			if (!strcmp(m_pmSQL->m_CurRow[4], ""))
			{
				printf("<td bgcolor=#d0eeed align=center><font size=-1>%s</font></td>", m_pmSQL->m_CurRow[1]);
			}
			else
			{
				printf("<td bgcolor=#d0eeed align=center><font size=-1><a href=mailto:%s></font><font size=-1>%s</font></a></td>", m_pmSQL->m_CurRow[4], m_pmSQL->m_CurRow[1]);
			}

			printf("<td bgcolor=#d0eeed align=center><font size=-1>%s</font></td>", m_pmSQL->m_CurRow[2]);
			printf("<td bgcolor=#d0eeed align=center><font size=-1>%s</font></td>", m_pmSQL->m_CurRow[5]);
			printf("<td bgcolor=#d0eeed align=center><font size=-1>%s</font></td>", m_pmSQL->m_CurRow[8]);
			printf("<td bgcolor=#d0eeed align=center><a href=%scgi-bin/MeetView.Cgi?BoardNum=%d&num=%d&id=%s><font size=-1>%s</font></a></td></tr>%c%c", m_pConfig->GetBaseDir(), m_pConfig->GetBoardNum(), iNum--, m_pmSQL->m_CurRow[0], m_pmSQL->m_CurRow[6], LF, LF);
			
			iCount++;
			m_iIndex++;
			if (iCount > 10)	break;
		}
		j++;
	}

	printf("</table>%c", LF);
	
	printf("<br>%c", LF);

	if (m_iIndex-10 > 0)
		printf("<font size=-1><a href=%scgi-bin/MeetBoard.Cgi?BoardNum=%d&TextNum=%d>[]</a></font>%c", m_pConfig->GetBaseDir(), m_pConfig->GetBoardNum(), iPrev, LF);

	printf("<font size=-1><a href=%scgi-bin/MeetHtml.Cgi?BoardNum=%d&TextNum=-1>[ۿø]</a></font>%c", m_pConfig->GetBaseDir(), m_pConfig->GetBoardNum(), LF);


	if (m_iIndex < m_pmSQL->mSQLGetNumRow())
	{
			printf("<font size=-1><a href=%scgi-bin/MeetBoard.Cgi?BoardNum=%d&TextNum=%d>[]</a></font>%c", m_pConfig->GetBaseDir(), m_pConfig->GetBoardNum(), m_iIndex, LF);
	}

	printf("<br><br>%c", LF);
	printf("<img src=%sImage/line.gif width=500><br>%c", m_pConfig->GetBaseDir(), LF);
	printf("<font color=4a708b size=-1>Copyright <font size=4>&copy</font> 1997,%c", LF);
	printf("Ver 2.3 <b>Software Engineering Lab.</b> All rights reserved.<br>%c", LF);
	printf("Dept. of Electronic Engineering. Chonbuk National Univ.<br>%c", LF);
	printf("<a href=http://sel.chonbuk.ac.kr/~jkkang/>Programmed by Kang Jul Ki</a><br>%c", LF);
	printf("<a href=mailto:%s>%s</a></br>%c", m_pConfig->GetEmail(), m_pConfig->GetEmail(), LF);
	printf("</font></center>%c", LF);

	printf("</body>%c", LF);
	printf("</html>%c", LF);

	m_pmSQL->mSQLClose();
}

void MeetBoard::Run()
{
	ShowMimeType();
	GetEnv();
	ShowBoard();
}

int MeetBoard::GetTotalDataBase(void)
{
	char	fname[255]="";
	FILE	*fp;
	HEADER	hd;

	/*
	** Make file name and path
	*/
	sprintf(fname, "%s%s", m_pConfig->GetBbsDir(), "guestbook.dat");

	fp = fopen(fname, "r");

	if (fp == NULL)
	{
		fp = fopen(fname, "w");

		hd.iIndex = 0;
		hd.iTotal = 0;
		fwrite(&hd, HEADER_SIZE, 1, fp);
	}

	fseek(fp, 0L, SEEK_SET);
	fread(&hd, HEADER_SIZE, 1, fp);

#ifdef _DEBUG_
	printf("hd.iTotal= %s%c<BR>", hd.iTotal, LF);
#endif
	fclose(fp);

	return	hd.iTotal;
}

void main(void)
{
	MeetBoard	MyMeetBoard;

	MyMeetBoard.Run();	
}
