/*
	MeetCorrect.cpp

	Author	: Kang Jul Ki (Master 2nd)
	E-mail	: jkkang@sel.chonbuk.ac.kr
	Homepage: http://sel.chonbuk.ac.kr/~jkkang/
	Date	: September 4, 1997
	Class	: Software Engineering Lab.
		  Dept. of Electronic Engineering
		  Chonbuk National Univ.	

	Compiler: gcc 2.7.2
	Copyright (c) 1997, Kang Jul Ki & Software Engineering Lab
*/

#include "MeetCorrect.h"

MeetCorrect::MeetCorrect()
{
	m_pParam	= new CGI_ENTRY[5];
	m_pConfig	= new Config;
	m_pmSQL		= new mSQL;
}

MeetCorrect::~MeetCorrect()
{
	delete	m_pParam;
	delete	m_pConfig;
	delete	m_pmSQL;
}

void MeetCorrect::GetEnv()
{
	int	i;

	/*
	** Get BoardNum from 'QUERY_STRING'
	*/
	m_cl   = atoi(getenv("CONTENT_LENGTH"));
	m_pBuf = getenv("QUERY_STRING");

	for (i=0; i<3; i++)
	{
		(m_pParam+i)->f_val  = (char *)makeword(m_pBuf, '&');
		(m_pParam+i)->f_name = (char *)makeword((m_pParam+i)->f_val, '=');
	}

	/*
	** Get BoardNum and TextNum
	** IF TextNum == -1
	**	Do Posting
	** ELSE
	**	Do Correct
	*/
	m_pConfig->m_iBoardNum  = atoi((m_pParam+0)->f_val);
	m_iNum			= atoi((m_pParam+1)->f_val);
	m_iID			= atoi((m_pParam+2)->f_val);

	for (i=0; m_cl && (!feof(stdin)); i++)
	{
		(m_pParam+i)->f_val	= fmakeword(stdin, '&', &m_cl);
		plustospace((m_pParam+i)->f_val);
		unescape_url((m_pParam+i)->f_val);
		(m_pParam+i)->f_name	= makeword((m_pParam+i)->f_val, '=');
	}

	/*
	** Get Config from 'GuestBook.conf'
	*/
	strcpy(m_szPasswd, (m_pParam+0)->f_val);
	m_pConfig->ProcessConfig();
}

void MeetCorrect::ShowHtml(void)
{
	char	szQuery[MAX_QUERY];
	FILE	*fpt;
	char	szTmp[10];
	fpos_t	pos;
	int	i = 0, ch;

	m_pmSQL->mSQLConnect(m_pConfig->GetDbName());
	m_pmSQL->mSQLSelectDB();

	sprintf(szQuery, "select * from %s where id=%d", m_pConfig->GetDbName(), m_iID);
	m_pmSQL->mSQLSetQuery(szQuery);
	m_pmSQL->mSQLQuery();
	m_pmSQL->mSQLStoreResult();

	m_pmSQL->m_CurRow = msqlFetchRow(m_pmSQL->m_Result);

	if (strcmp(m_szPasswd, m_pConfig->GetPassword()) && strcmp(m_pmSQL->m_CurRow[7], m_szPasswd))
	{
		ShowPasswdError();
		msqlFreeResult(m_pmSQL->m_Result);
		m_pmSQL->mSQLClose();
		exit(1);
	}

	printf("<html>%c", LF);
	printf("<head>%c", LF);
	printf("<title>Խ  2.3</title>%c", LF);
	printf("</head>%c", LF);
	printf("<body bgcolor=white>%c", LF);

	printf("<center>%c", LF);
	printf("<img src=%sImage/%s border=0>%c", m_pConfig->GetBaseDir(), m_pConfig->GetImageName(), LF);
	printf("<table border=0 width=480 cellpading=0>%c", LF);
	  printf("<tr>%c", LF);
	    printf("<td valign=buttom>%c", LF);
	    printf("<img align=left border=0 src=%sImage/bookpen.gif>%c", m_pConfig->GetBaseDir(), LF);
	      printf("<br>%c", LF);
	    printf("<img width=420 src=%sImage/line_ani.gif>%c", m_pConfig->GetBaseDir(), LF); 
	    printf("</td>%c", LF);
	  printf("</tr>%c", LF);
	printf("</table>%c", LF);
	printf("</center>%c", LF);

	printf("<center>%c", LF);
	printf("<form method=post action=%scgi-bin/MeetUpdate.Cgi?BoardNum=%d&num=%d&id=%d>%c", m_pConfig->GetBaseDir(), m_pConfig->GetBoardNum(), m_iNum, m_iID, LF);
	printf("<table>%c", LF);

	printf("<tr><td align=right><font size=-1≯</font></td><td><input type=text name=name size=20 maxlength=18 value=\"%s\"></td></tr>%c", m_pmSQL->m_CurRow[1], LF);
	printf("<tr><td align=right><font size=-1>E-mail</font></td><td><input type=text name=email size=40 maxlength=40 value=\"%s\"></td></tr>%c", m_pmSQL->m_CurRow[4], LF);
	printf("<tr><td align=right><font size=-1>Ȩ</font></td><td><input type=text name=homepage value=\"%s\" size=60%c", m_pmSQL->m_CurRow[9], LF);

	printf("maxlength=60></td><tr>%c", LF);

	printf("<tr><td align=right><font size=-1></font></td><td><input type=text name=subject size=60 maxlength=140 value=\"%s\"></td></tr>%c", m_pmSQL->m_CurRow[6], LF);
	printf("<tr><td align=right><font size=-1>н(ִ10)</font></td><td><input type=password name=passwd size=10 maxlength=10 value=\"%s\"></td></tr>%c", m_pmSQL->m_CurRow[7], LF);
	printf("<tr><td align=right><font size=-1>ϰ</font></td><td><textarea type=text name=body cols=60 rows=10>%c", LF);
	
	fpt = fopen(m_pmSQL->m_CurRow[11], "r");

	while ((ch = getc(fpt)) != EOF)
	{
		if (ch == '<')
		{
			fgetpos(fpt, &pos);
			szTmp[0] = '<';
			for (i=1; i<=3; i++)
				szTmp[i] = getc(fpt);
			szTmp[i] = '\0';
			
			if (!strcmp(szTmp, "<br>"))
			{
				;
			}
			else
			{
				fsetpos(fpt, &pos);
				putchar(ch);
			}
		}
		else
		{
			putchar(ch);
		}
	}

	fclose(fpt);

	printf("</textarea>%c", LF);
	printf("</td></tr></table>%c", LF);

	printf("<br>%c", LF);
 
	printf("<center>%c", LF);
		printf("<input type=submit value=\" ø\">%c", LF);
		printf("<input type=reset value=\"ϱ\">%c", LF);
	printf("</center>%c", LF);

	printf("</form>%c", LF);
	printf("<br>%c", LF);
	printf("</center>%c", LF);

	printf("<p>%c", LF);

	printf("<center>%c", LF);
	printf("<img src=%sImage/line.gif>%c", m_pConfig->GetBaseDir(), LF);
	printf("<br>%c", LF);

	printf("<font color=4a708b size=-1>Copyright <font size=4>&copy</font> 1996 - 1997,%c", LF);
	printf("Ver 2.3 <b>Software Engineering Lab</b>. All rights reserved.<br>%c", LF);
	printf("Chonbuk National Univ. Dept. of Electronic Engineering<br>%c", LF);
	printf("<a href=http://sel.chonbuk.ac.kr/~jkkang/>Programmed by Kang Jul Ki</a><br>%c", LF);
	printf("<a href=mailto:%s>%s</a><br>%c", m_pConfig->GetEmail(), m_pConfig->GetEmail(), LF);
	printf("</font>%c", LF);
	printf("</center>%c", LF);

	printf("</body>%c", LF);
	printf("</html>%c", LF);

	/*
	** Disconnect to the Database Server
	*/
	msqlFreeResult(m_pmSQL->m_Result);
	m_pmSQL->mSQLClose();
}

void MeetCorrect::ShowPasswdError()
{
	printf("<html>%c", LF);
	printf("<head><title>н </title></head>%c", LF);
	printf("<meta http-equiv=\"Content-Type\" Content=\"text/html; charset=euc-kr\">%c", LF);
	printf("<body bgcolor=white>%c", LF);

	printf("<center>%c", LF);
	
	printf("<br><br><br><br>%c", LF);

	printf("<font size=-1>н Դϴ.</font>%c", LF);
	printf("<br><br><br><br>%c", LF);
	
	printf("<br><br><br><br>%c", LF);
	printf("<a href=http://sel.chonbuk.ac.kr/~jkkang/ target=_top><img src=%sImage/designer.gif border=0></a><br>%c", m_pConfig->GetBaseDir(), LF);

	printf("</center>%c", LF);
	printf("</body>%c", LF);
	printf("</html>%c", LF);
}

void MeetCorrect::Run(void)
{
	ShowMimeType();
	GetEnv();

	ShowHtml();
}

void main()
{
	MeetCorrect	MyMeetCorrect;

	MyMeetCorrect.Run();
}
