/*
	MeetErase.cpp

	Author	: Kang Jul Ki (Master 2nd)
	E-mail	: jkkang@sel.chonbuk.ac.kr
	Homepage: http://sel.chonbuk.ac.kr/~jkkang/
	Date	: September 4, 1997
	Class	: Software Engineering Lab.
		  Dept. of Electronic Engineering
		  Chonbuk National Univ.	

	Compiler: gcc 2.7.2
	Copyright (c) 1997, Kang Jul Ki & Software Engineering Lab
*/

#include "MeetErase.h"

MeetErase::MeetErase()
{
	m_pHeader	= new HEADER;
	m_pConfig	= new Config;
	m_pParam	= new CGI_ENTRY[2];
	m_pmSQL		= new mSQL;
}

MeetErase::~MeetErase()
{
	delete		m_pConfig;
	delete		m_pParam;
	delete		m_pmSQL;
}

void MeetErase::GetEnv(void)
{
	int	i;

	/*
	** Get environment variable from HTTP
	*/
	m_cl   = atoi(getenv("CONTENT_LENGTH"));
	m_pBuf = getenv("QUERY_STRING");
	
	for (i=0; i<2; i++)
	{
		(m_pParam+i)->f_val	= (char *)makeword(m_pBuf, '&');
		(m_pParam+i)->f_name	= (char *)makeword((m_pParam+i)->f_val, '=');
	}

	m_pConfig->m_iBoardNum	= atoi((m_pParam+0)->f_val);
	m_iID			= atoi((m_pParam+1)->f_val);

	for (i=0; m_cl && (!feof(stdin)); i++)
	{
		(m_pParam+i)->f_val	= fmakeword(stdin, '&', &m_cl);
		plustospace((m_pParam+i)->f_val);
		unescape_url((m_pParam+i)->f_val);
		(m_pParam+i)->f_name	= makeword((m_pParam+i)->f_val, '=');
	}

	strcpy(m_szPasswd, (m_pParam+0)->f_val);
	m_pConfig->ProcessConfig();
}

void MeetErase::ShowMimeType(void)
{
	printf("Content-type: text/html%c%c", LF, LF);
}

void MeetErase::DeleteData(void)
{
	char	szQuery[MAX_QUERY];

	m_pmSQL->mSQLConnect(m_pConfig->GetDbName());
	m_pmSQL->mSQLSelectDB();

	sprintf(szQuery, "select passwd from %s where id=%d", m_pConfig->GetDbName(), m_iID);
	m_pmSQL->mSQLSetQuery(szQuery);
	m_pmSQL->mSQLQuery();
	m_pmSQL->mSQLStoreResult();

	m_pmSQL->m_CurRow = msqlFetchRow(m_pmSQL->m_Result);

	if (strcmp(m_szPasswd, m_pConfig->GetPassword()) &&  strcmp(m_pmSQL->m_CurRow[0], m_szPasswd))
	{
		ShowPasswdError();
		msqlFreeResult(m_pmSQL->m_Result);
		m_pmSQL->mSQLClose();
		exit(1);
	}
	msqlFreeResult(m_pmSQL->m_Result);

	sprintf(szQuery, "delete from %s where id=%d", m_pConfig->GetDbName(), m_iID);
	m_pmSQL->mSQLSetQuery(szQuery);
	m_pmSQL->mSQLQuery();

	printf("<html>%c", LF);
	printf("<head>%c", LF);
	printf("<title>-</title>%c", LF);
	printf("<meta http-equiv=\"Content-Type\" Content=\"text/html; charset=euc-kr\">%c", LF);
	printf("</head>%c", LF);

	printf("<body bgcolor=white>%c", LF);
	printf("<center>%c", LF);
			
	printf("<br><br><br><br>%c", LF);

	printf("<font size=-1> ϴ.</font>%c", LF);
	printf("<br><br><br><br>%c", LF);
	printf("<font size=-1><a href=%scgi-bin/MeetBoard.Cgi?BoardNum=%d&TextNum=0>[Ϻ]</a></font>%c", m_pConfig->GetBaseDir(), m_pConfig->GetBoardNum(), LF);

	printf("<br><br><br><br>%c", LF);
	
	printf("<a href=http://sel.chonbuk.ac.kr/~jkkang/ target=_top><img src=%sImage/designer.gif border=0></a><br>%c", m_pConfig->GetBaseDir(), LF);
	printf("</center>%c", LF);

	printf("</body>%c", LF);
	printf("</html>%c", LF);

	m_pmSQL->mSQLClose();
}

void MeetErase::UpdateHeader(void)
{
	char	fname[255]="";
	FILE	*fpt;
	int	iTotal;

	/*
	** Make file name and path
	*/
	sprintf(fname, "%s%s", m_pConfig->GetBbsDir(), "guestbook.dat");

	fpt = fopen(fname, "r+");

	fseek(fpt, 0L, SEEK_SET);
	fread(m_pHeader, HEADER_SIZE, 1, fpt);

	iTotal = m_pHeader->iTotal - 1;
	if (iTotal < 0) m_pHeader->iTotal = 0;

	m_pHeader->iTotal = iTotal;

	fseek(fpt, 0L, SEEK_SET);
	fwrite(m_pHeader, HEADER_SIZE, 1, fpt);

	fclose(fpt);
}

void MeetErase::ShowPasswdError()
{
	printf("<html>%c", LF);
	printf("<head><title>н </title></head>%c", LF);
	printf("<meta http-equiv=\"Content-Type\" Content=\"text/html; charset=euc-kr\">%c", LF);
	printf("<body bgcolor=white>%c", LF);

	printf("<center>%c", LF);
	
	printf("<br><br><br><br>%c", LF);

	printf("<font size=-1>н Դϴ.</font>%c", LF);
	printf("<br><br><br><br>%c", LF);
	
	printf("<br><br><br><br>%c", LF);
	printf("<a href=http://sel.chonbuk.ac.kr/~jkkang/ target=_top><img src=%sImage/designer.gif border=0></a><br>%c", m_pConfig->GetBaseDir(), LF);

	printf("</center>%c", LF);
	printf("</body>%c", LF);
	printf("</html>%c", LF);
}

void MeetErase::Run(void)
{
	ShowMimeType();
	GetEnv();
	DeleteData();
	UpdateHeader();
}

void main()
{
	MeetErase	MyMeetErase;

	MyMeetErase.Run();
}
