/*
	MeetPost.cpp

	Author	: Kang Jul Ki (Master 2nd)
	E-mail	: jkkang@sel.chonbuk.ac.kr
	Homepage: http://sel.chonbuk.ac.kr/~jkkang/
	Date	: August 21, 1997
	Class	: Software Engineering Lab.
		  Dept. of Electronic Engineering
		  Chonbuk National Univ.	

	Compiler: gcc 2.7.2
	Copyright (c) 1997, Kang Jul Ki & Software Engineering Lab
*/

#include "MeetPost.h"

MeetPost::MeetPost()
{
	m_pParam	= new CGI_ENTRY[5];
	m_pHeader	= new HEADER;
	m_pmSQL		= new mSQL;
	m_pConfig	= new Config; 

	m_szDomain	= NULL;
	m_szIp		= NULL;
	tmp_time2	= NULL;

	m_iLine		= 0;
}

MeetPost::~MeetPost()
{
	delete	m_pParam;
	delete	m_pHeader;
	delete	m_pmSQL;
	delete	m_pConfig;
}

void MeetPost::GetEnv()
{
	int	i;

	/*
	** Get environment variable from INPUT_TYPE
	*/
	m_cl		= atoi(getenv("CONTENT_LENGTH"));
	m_szDomain	= getenv("REMOTE_HOST");
	m_szIp		= getenv("REMOTE_ADDR");

	/*
	** Set time and date of writing
	*/
	tmp_time1 = time(0);
	tmp_time2 = localtime(&tmp_time1);
	strftime(m_szwhDate, 99, "%Y%m%d", tmp_time2);
	strftime(m_szwhTime, 99, "%H%M", tmp_time2);
	sprintf(m_szDate, "%s %s", m_szwhDate, m_szwhTime);

	/*
	** Get BoardNum from 'QUERY_STRING'
	*/
	m_pBuf = getenv("QUERY_STRING");

	for (i=0; i<2; i++)
	{
		(m_pParam+i)->f_val  = (char *)makeword(m_pBuf, '&');
		(m_pParam+i)->f_name = (char *)makeword((m_pParam+i)->f_val, '=');
	}

	/*
	** Get BoardNum and TextNum
	** IF TextNum == -1
	**	Do Posting
	** ELSE
	**	Do Correct
	*/
	m_pConfig->m_iBoardNum = atoi((m_pParam+0)->f_val);
	m_pConfig->m_iTextNum  = atoi((m_pParam+1)->f_val);

	/*
	** Get content
	*/
	for (i=0; m_cl && (!feof(stdin)); i++)
	{
		(m_pParam+i)->f_val	= fmakeword(stdin, '&', &m_cl);
		plustospace((m_pParam+i)->f_val);
		unescape_url((m_pParam+i)->f_val);
		(m_pParam+i)->f_name	= makeword((m_pParam+i)->f_val, '=');

#ifdef _DEBUG_
	printf("%s : %s%c<br>", (m_pParam+i)->f_name, (m_pParam+i)->f_val, LF);
#endif
	}

	/*
	** Get Config from 'GuestBook.conf'
	*/
	m_pConfig->ProcessConfig();

	if (IsOkPost() == ERR)
	{
		ShowError();
		exit(1);
	}
}

void MeetPost::GetHeader(void)
{
	char	fname[255]="";
	FILE	*fpt;

	/*
	** Make file name and path
	*/
	sprintf(fname, "%s%s", m_pConfig->GetBbsDir(), "guestbook.dat");

	fpt = fopen(fname, "r+");

	/*
	** If file doesn't exist, create new file
	*/
	if (fpt == NULL)
	{
		fpt = fopen(fname, "w");

		m_pHeader->iIndex = 0;
		m_pHeader->iTotal = 0;
		fwrite(m_pHeader, HEADER_SIZE, 1, fpt);
	}

	fseek(fpt, 0L, SEEK_SET);
	fread(m_pHeader, HEADER_SIZE, 1, fpt);

	m_pConfig->m_iIndex = m_pHeader->iIndex + 1;
	m_pConfig->m_iTotal = m_pHeader->iTotal + 1;

	m_pHeader->iIndex = m_pConfig->m_iIndex;
	m_pHeader->iTotal = m_pConfig->m_iTotal;

	fseek(fpt, 0L, SEEK_SET);
	fwrite(m_pHeader, HEADER_SIZE, 1, fpt);

#ifdef _DEBUG_
	printf("m_pConfig->iIndex = %d m_pConfig->iTotal = %d%c<BR>", m_pConfig->m_iIndex, m_pConfig->m_iTotal, LF);
#endif

	fclose(fpt);
}

int MeetPost::GetLine(void)
{
	for (int i=0; i<(int)strlen((m_pParam+5)->f_val); i++)
	{
		if (*(((m_pParam+5)->f_val)+i) == CR)	m_iLine++;
	}

	if (m_iLine == 0)	return	(m_iLine+1);
	else			return	(m_iLine+1);
}	

stat MeetPost::IsOkPost(void)
{
	/*
	** Show error message
	**    Don't write 
	*/
	if (strlen((m_pParam+0)->f_val) <= 0 ||
	    strlen((m_pParam+1)->f_val) <= 0 ||
	    strlen((m_pParam+2)->f_val) <= 0 ||
	    strlen((m_pParam+3)->f_val) <= 0 ||
	    strlen((m_pParam+4)->f_val) <= 0 ||
	    strlen((m_pParam+5)->f_val) <= 0)
	{
		return	ERR;
	}

	return	OK;
}

void MeetPost::AddRecordIntoFile(void)
{
	char	szQuery[MAX_QUERY];
	int	j = 0;

	sprintf(m_szHtmlFileName, "%s%s%d.html", m_pConfig->GetBbsDir(), "guestbook", m_pConfig->GetIndex());

	/*
	** Get ID
	*/
	m_iID = GetID();

	/*
	** Making up query sentence
	*/
	sprintf(szQuery, "insert into %s (id,name,date,time,email,count,title,passwd,line,url,domain,htmlfile)\
			values (%d,'%s','%s','%s','%s',%d,'%s','%s',%d,'%s','%s','%s')",
			m_pConfig->GetDbName(),
			m_iID,			/* id	*/
			(m_pParam+0)->f_val,	/* name	*/
			m_szwhDate,		/* date	*/
			m_szwhTime,		/* time	*/
			(m_pParam+1)->f_val,	/* email*/
			0,			/* count*/
			(m_pParam+3)->f_val,	/* title*/
			(m_pParam+4)->f_val,	/* passwd*/
			GetLine(),		/* line */
			(m_pParam+2)->f_val,	/* url	*/
			m_szDomain,		/* domain*/
			m_szHtmlFileName);	/* html file*/

	m_pmSQL->mSQLSetQuery(szQuery);
	m_pmSQL->mSQLQuery();
}

void MeetPost::MakeNewHtmlFile(void)
{
	FILE	*fpt;

	/*
	** Show 'guestbook#.html' in the screen
	*/
	fpt = fopen(m_szHtmlFileName, "w");

	if (fpt == NULL)
	{
		printf("Can't open %s.%c", m_szHtmlFileName, LF);
		exit(1);
	}

	/*
	** Write contents in the file
	*/
	for (int i=0; i<(int)strlen((m_pParam+5)->f_val); i++)
	{
		if (*(((m_pParam+5)->f_val)+i) == CR)
		{
			fprintf(fpt, "<br>");
		}
		else
		{
			putc(*(((m_pParam+5)->f_val)+i), fpt);
		}
	}

	fclose(fpt);
}

void MeetPost::ShowNewHtmlFile(void)
{
	char	ch;
	FILE	*fpt;

	/*
	** Show 'guestbook#.html' in the screen
	*/
	fpt = fopen(m_szHtmlFileName, "r");
	
	if (fpt == NULL)
	{
		printf("Can't open %s.%c", m_szHtmlFileName, LF);
		exit(1);
	}

	printf("<html>%c", LF);
	printf("<head>%c", LF);
	printf("<title>Խ  2.3</title>%c", LF);
	printf("</head>%c", LF);
	printf("<body bgcolor=white>%c", LF);

	printf("<center>%c", LF);
	printf("<table border=0><caption><b><font size=-1>%s</font></b></caption>%c", (m_pParam+3)->f_val, LF);

	printf("<tr><th><font size=-1>۹ȣ</font></th><td><font size=-1>%d</font></td><th><font size=-1>Ƚ</font></th><td><font size=-1>%d</font></td></tr>%c",	m_pHeader->iTotal, 0, LF);
	printf("<tr><th><font size=-1>۾</font></th><td><font size=-1>%s</font></td><th><font size=-1>۾¥</font></th><td><font size=-1>%s</font></td></tr>%c", (m_pParam+0)->f_val, m_szwhDate, LF);
	printf("<tr><th><font size=-1>E-mail</font></th><td><a href=mailto:%s><font size=-1>%s</font></a></td>", (m_pParam+1)->f_val, (m_pParam+1)->f_val);
	printf("<th><font size=-1>URL</font></th><td><a href=http://%s><font size=-1>%s</font></a></td></tr>%c", m_szDomain, m_szDomain, LF);
	printf("<tr><th><font size=-1>Homepage</font></th><td><a href=%s><font size=-1>%s</font></a></td>%c", (m_pParam+2)->f_val, (m_pParam+2)->f_val, LF);
	printf("<th><font size=-1>ټ</font></th><td><font size=-1>%d</font></td></th></tr>%c", m_iLine, LF);
	printf("</table>%c", LF);

	printf("<img width=420 src=%sImage/blue_line.gif>%c", m_pConfig->GetBaseDir(), LF);
	printf("<br><br>%c", LF);

	printf("<table border=0>%c", LF);
	printf("<tr><td><font size=-1>%c", LF);

	/*
	** Show contents in the file
	*/
	while ((ch = getc(fpt)) != EOF)
		putchar(ch);

	printf("</font></table>%c", LF);
	printf("<br>%c", LF);

	printf("<img src=%sImage/line.gif width=500><br>%c", m_pConfig->GetBaseDir(), LF);
	printf("<font color=006400 size=-1>Copyright <font size=4>&copy</font> 1996 - 1997,%c", LF);
	printf("Ver 2.3 <b>Software Engineering Lab.</b> All rights reserved.<br>%c", LF);
	printf("<a href=http://sel.chonbuk.ac.kr/~jkkang/>Programmed by Kang Jul Ki</a><br>%c", LF);
	printf("<a href=mailto:%s>%s</a><br>%c", m_pConfig->GetEmail(), m_pConfig->GetEmail(), LF);
	printf("</font>%c", LF);

	printf("<br>%c", LF);
	printf("<font color=4a708b size=-1>%c", LF);
	printf("<a href=%scgi-bin/MeetBoard.Cgi?BoardNum=%d&TextNum=0><img src=%sImage/posting.gif border=0></a>%c", m_pConfig->GetBaseDir(), m_pConfig->GetBoardNum(), m_pConfig->GetBaseDir(), LF);
	printf("<br>Click%c", LF);
	printf("</font>%c", LF);

	printf("</center>%c", LF);
	printf("</body>%c", LF);
	printf("</html>%c", LF);

	fclose(fpt);
}

void MeetPost::ShowError()
{
	/*
	** Return result into HTML document
	** Just write into stdout and exit(0)
	*/
	printf("<html>%c", LF);
	printf("<head>%c", LF);
	printf("<title>Խ  2.3</title>%c", LF);
	printf("</head>%c", LF);
	printf("<body bgcolor=white>%c", LF);
	printf("<center>%c", LF);

	printf("<img border=0 src=%sImage/%s><br><br>%c", m_pConfig->GetBaseDir(), m_pConfig->GetImageName(), LF);

	printf("<br><br><br>%c", LF);
	printf("<img src=%sImage/line_ani.gif><br><br>%c", m_pConfig->GetBaseDir(), LF);
        printf("<font size=-1>湮 ̸, ,  ּ!!!</font><br>%c", LF);
	printf("<font size=-1>You should write your name, title and comment!!!</font></center>%c", LF);
	printf("<br><br><br>%c", LF);

	printf("<center><a href=%scgi-bin/MeetHtml.Cgi?BoardNum=%d&TextNum=-1><img border=0 src=%sImage/before.gif></a></center>%c", m_pConfig->GetBaseDir(), m_pConfig->GetBoardNum(), m_pConfig->GetBaseDir(), LF);
	printf("</body>%c", LF);
	printf("</html>%c", LF);

	exit(1);
}

void MeetPost::Run(void)
{
	ShowMimeType();
	GetEnv();
	GetHeader();

	m_pmSQL->mSQLConnect(m_pConfig->GetDbName());
	m_pmSQL->mSQLSelectDB();

	AddRecordIntoFile();
	MakeNewHtmlFile();
	ShowNewHtmlFile();

	m_pmSQL->mSQLClose();
}

void main()
{
	MeetPost	MyMeetPost;

	MyMeetPost.Run();
}
