/*
	CGI Source for MeetView.cpp

	Author	: Kang Jul Ki (Master 2nd)
	E-mail	: jkkang@sel.chonbuk.ac.kr
	Homepage: http://sel.chonbuk.ac.kr/~jkkang/
	Date	: August 21, 1997
	Class	: Software Engineering Lab.
		  Dept. of Electronic Engineering
		  Chonbuk National Univ.	

	Compiler: gcc 2.7.2
	Copyright (c) 1997, Kang Jul Ki & Software Engineering Lab
*/

#include "MeetView.h"

MeetView::MeetView()
{
	m_pmSQL		= new mSQL;
	m_pParam	= new CGI_ENTRY[3];
	m_pConfig	= new Config;
}

MeetView::~MeetView()
{
	delete	m_pmSQL;
	delete	m_pParam;
	delete	m_pConfig;
}

void MeetView::GetEnv()
{
	/*
	** Get environment variable from HTTP
	*/
	m_pBuf = getenv("QUERY_STRING");
	
	for (int i=0; i<3; i++)
	{
		(m_pParam+i)->f_val  = (char *)makeword(m_pBuf, '&');
		(m_pParam+i)->f_name = (char *)makeword((m_pParam+i)->f_val, '=');
	}

	m_pConfig->m_iBoardNum = atoi((m_pParam+0)->f_val);
	m_iNum = atoi((m_pParam+1)->f_val);
	m_iID = atoi((m_pParam+2)->f_val);

	m_pConfig->ProcessConfig();
}

void MeetView::ShowMimeType()
{
	printf("Content-type: text/html%c%c", LF, LF);
}

void MeetView::ShowView()
{
	char	ch;
	char	szDate[100] = "";
	char	szQuery[MAX_QUERY];
	int	iLeft, iRight, iTotal, iCount;
	FILE	*fp;
	
	iTotal = GetTotalDataBase();

	m_pmSQL->mSQLConnect(m_pConfig->GetDbName());
	m_pmSQL->mSQLSelectDB();

	sprintf(szQuery, "select * from %s where id=%d", m_pConfig->GetDbName(), m_iID);
	m_pmSQL->mSQLSetQuery(szQuery);
	m_pmSQL->mSQLQuery();
	m_pmSQL->mSQLStoreResult();

	m_pmSQL->m_CurRow = msqlFetchRow(m_pmSQL->m_Result);
	iCount = atoi(m_pmSQL->m_CurRow[5]);

	sprintf(szDate, "%s %s", m_pmSQL->m_CurRow[2], m_pmSQL->m_CurRow[3]);

	printf("<html>%c", LF);
	printf("<head><title>Խ  2.3</title></head>%c", LF);
	printf("<body bgcolor=white>%c", LF);

	printf("<center>%c", LF);
	printf("<table border=0><caption><b><font size=-1>%s</font></b></caption>%c", m_pmSQL->m_CurRow[6], LF);

	printf("<tr><th><font size=-1>۹ȣ</font></th><td><font size=-1>%d</font></td><th><font size=-1>Ƚ</font></th><td><font size=-1>%d</font></td></tr>%c", m_iNum, atoi(m_pmSQL->m_CurRow[5])+1, LF);
	printf("<tr><th><font size=-1>۾</font></th><td><font size=-1>%s</font></td><th><font size=-1>۾¥</font></th><td><font size=-1>%s</font></td></tr>%c",	m_pmSQL->m_CurRow[1], szDate, LF);
	printf("<tr><th><font size=-1>E-mail</font></th><td><a href=mailto:%s><font size=-1>%s</font></a></td>", m_pmSQL->m_CurRow[4], m_pmSQL->m_CurRow[4]);
	printf("<th><font size=-1>URL</font></th><td><a href=http://%s><font size=-1>%s</font></a></td></tr>%c", m_pmSQL->m_CurRow[10], m_pmSQL->m_CurRow[10], LF);
	printf("<tr><th><font size=-1>Homepage</font></th><td><a href=%s><font size=-1>%s</font></a></td>%c", m_pmSQL->m_CurRow[9], m_pmSQL->m_CurRow[9], LF);
	printf("<th><font size=-1>ټ</font></th><td><font size=-1>%s</font></td></th></tr>%c", m_pmSQL->m_CurRow[8], LF);
	printf("</table>%c", LF);

	printf("<img width=420 src=%sImage/blue_line.gif>%c", m_pConfig->GetBaseDir(), LF);
	printf("<br><br>%c", LF);

	printf("<table border=0>%c", LF);
	printf("<tr><td><font size=-1>%c", LF);

	/*
	** Show contents in the file
	*/
	fp = fopen(m_pmSQL->m_CurRow[11], "r");
	
	if (fp == NULL)
	{
		printf("<html>%c", LF);
		printf("<body>%c", LF);
		printf("%s is not found!!!%c", m_pmSQL->m_CurRow[11], LF);

		printf("</body>%c", LF);
		printf("</html>%c", LF);
		exit(1);
	}

	while ((ch = getc(fp)) != EOF)
		putchar(ch);

	fclose(fp);

	printf("</font></table>%c", LF);
	printf("<br><br>%c", LF);

	/*
	** Prev and Next
	*/
	iLeft  = m_iNum + 1;
	iRight = m_iNum - 1;

	msqlFreeResult(m_pmSQL->m_Result);

	if (iLeft <= iTotal)
	{
		sprintf(szQuery, "select id,title from %s where id > %d order by id LIMIT 1", m_pConfig->GetDbName(), m_iID);
		m_pmSQL->mSQLSetQuery(szQuery);
		m_pmSQL->mSQLQuery();
		m_pmSQL->mSQLStoreResult();

		m_pmSQL->m_CurRow = msqlFetchRow(m_pmSQL->m_Result);
	
		printf("<font size=-1>[<font color=green>:</font><a href=%scgi-bin/MeetView.Cgi?BoardNum=%d&num=%d&id=%s>", m_pConfig->GetBaseDir(), m_pConfig->GetBoardNum(), iLeft, m_pmSQL->m_CurRow[0]);
		printf("<font size=-1>%s</font>%c", m_pmSQL->m_CurRow[1], LF);
		printf("</a>]</font>%c", LF);
	}

	/*
	** Go to Center
	*/
	printf("<a href=%scgi-bin/MeetBoard.Cgi?BoardNum=%d&TextNum=0>", m_pConfig->GetBaseDir(), m_pConfig->GetBoardNum());
	printf("<font size=-1>[Ϻ]</font></a>%c", LF);

	if (iRight != 0)
	{
		sprintf(szQuery, "select id,title from %s where id < %d order by id DESC LIMIT 1", m_pConfig->GetDbName(), m_iID);

		m_pmSQL->mSQLSetQuery(szQuery);
		m_pmSQL->mSQLQuery();
		m_pmSQL->mSQLStoreResult();
		m_pmSQL->m_CurRow = msqlFetchRow(m_pmSQL->m_Result);

		if (m_pmSQL->m_CurRow == NULL)
			printf("NULL");
#ifdef DEBUG
	printf("success");
	exit(1);
#endif
		printf("<font size=-1>[<font color=green>:</font><a href=%scgi-bin/MeetView.Cgi?BoardNum=%d&num=%d&id=%s>", m_pConfig->GetBaseDir(), m_pConfig->GetBoardNum(), iRight, m_pmSQL->m_CurRow[0]);
		printf("<font size=-1>%s</font>%c", m_pmSQL->m_CurRow[1], LF);
		printf("</a>]</font>%c", LF);
	}

	printf("<br>%c", LF);
	printf("<a href=%scgi-bin/CPasswd.Cgi?BoardNum=%d&num=%d&id=%d><font size=-1>[ϱ]</font></a>%c", m_pConfig->GetBaseDir(), m_pConfig->GetBoardNum(), m_iNum, m_iID, LF);
	printf("<a href=%scgi-bin/EPasswd.Cgi?BoardNum=%d&id=%d><font size=-1>[ϱ]</font></a>%c", m_pConfig->GetBaseDir(), m_pConfig->GetBoardNum(), m_iID, LF);
	printf("<br><img width=420 src=%sImage/blue_line.gif>%c", m_pConfig->GetBaseDir(), LF);
	
	printf("<br><font color=4a708b size=-1>%c", LF);
	printf("<a href=http://sel.chonbuk.ac.kr/~jkkang/>Programmed by Kang Jul Ki</a><br>%c", LF);
	printf("<a href=mailto:%s>%s</a></br>%c", m_pConfig->GetEmail(), m_pConfig->GetEmail(), LF);

	printf("</font></center>%c", LF);
	printf("</body>%c", LF);
	printf("</html>%c", LF);
	/*
	** Update count by 1.
	*/
	sprintf(szQuery, "update %s set count=%d where id=%d", m_pConfig->GetDbName(), iCount+1, m_iID);
	m_pmSQL->mSQLSetQuery(szQuery);
	m_pmSQL->mSQLQuery();
	m_pmSQL->mSQLClose();
}

int MeetView::GetTotalDataBase(void)
{
	char	fname[255]="";
	FILE	*fp;
	HEADER	hd;

	/*
	** Make file name and path
	*/
	sprintf(fname, "%s%s", m_pConfig->GetBbsDir(), "guestbook.dat");

	fp = fopen(fname, "r+");

	fseek(fp, 0L, SEEK_SET);
	fread(&hd, HEADER_SIZE, 1, fp);

#ifdef _DEBUG_
	printf("hd.iTotal= %d%c<BR>", hd.iTotal, LF);
#endif
	fclose(fp);

	return	hd.iTotal;
}

void MeetView::Run()
{
	ShowMimeType();
	GetEnv();
	ShowView();
}

void main()
{
	MeetView	MyMeetView;

	MyMeetView.Run();
}
