/*
	MeetView.h

	Author	: Kang Jul Ki (Master 2nd)
	E-mail	: jkkang@sel.chonbuk.ac.kr
	Homepage: http://sel.chonbuk.ac.kr/~jkkang/
	Date	: August 21, 1997
	Class	: Software Engineering Lab.
		  Dept. of Electronic Engineering
		  Chonbuk National Univ.	

	Compiler: gcc 2.7.2
	Copyright (c) 1997, Kang Jul Ki & Software Engineering Lab
*/

#ifndef __MeetView_h_
#define __MeetView_h_

#include "MyCgi.h"
#include "Config.h"
#include "Cgi.h"
#include "mSQL.h"

class MeetView : public Cgi
{
	mSQL*	m_pmSQL;
	Config*	m_pConfig;

	int	m_iNum;
	int	m_iID;
	int	m_iPrevID;
	int	m_iNextID;

	char	m_szPrevTitle[MAX_LEN];
	char	m_szNextTitle[MAX_LEN];
	
public:
	MeetView();
	~MeetView();

	void	GetEnv();
	void	ShowMimeType();
	void	ShowView();
	void	Run();

	void	SetPrevID(int iID)	{ m_iPrevID = iID; }
	void	SetNextID(int iID)	{ m_iNextID = iID; }

	void	SetPrevTitle(char *szTitle)	{ strcpy(m_szPrevTitle, szTitle); }
	void	SetNextTitle(char *szTitle)	{ strcpy(m_szNextTitle, szTitle); }

	int	GetPrevID(void) const { return	m_iPrevID; }
	int	GetNextID(void) const { return	m_iNextID; }

	char*	GetPrevTitle(void) { return m_szPrevTitle; }
	char*	GetNextTitle(void) { return m_szNextTitle; }

	int	GetTotalDataBase(void);
};

#endif




