/*
	MyCgi.h

	Author	: Kang Jul Ki (Master 2nd)
	E-mail	: jkkang@sel.chonbuk.ac.kr
	Homepage: http://sel.chonbuk.ac.kr/~jkkang/
	Date	: August 21, 1997
	Class	: Software Engineering Lab.
		  Dept. of Electronic Engineering
		  Chonbuk National Univ.	

	Compiler: gcc 2.7.2
	Copyright (c) 1997, Kang Jul Ki & Software Engineering Lab
*/

#ifndef __MyCgi_h_
#define __MyCgi_h_

#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#ifndef __cplusplus
#error	"This program isn't supported in Non-C++ code"
#endif

enum stat { ERR = -1, OK = 1 };

#define	CR		13
#define	LF		10
#define MAX_ENTRIES	100
#define	MAX_QUERY	1024

#define	MAX_LEN		255

typedef struct tagENTRY
{
    char *f_name;
    char *f_val;
} CGI_ENTRY;

/*
** File Header in the data file.
*/
typedef struct tagHEADER
{
	int	iIndex;		/* number of guestbook#.html	*/
	int	iTotal;		/* total number of html file	*/
} HEADER;

#define	HEADER_SIZE		(sizeof(HEADER))

/*
** Data format
*/
typedef struct tagDB
{
	int	iID;			/* record id	*/
	char	szName[20+1];		/* writer's name*/
	char	szDate[20+1];		/* date		*/
	char	szTime[20+1];		/* time		*/
	char	szEmail[40+1];		/* email	*/
	int	iCount;			/* counter	*/
	char	szTitle[140+1];		/* title	*/
	char	szPassword[10+1];	/* password	*/
	int	iLine;			/* line		*/
	char	szURL[60+1];		/* url		*/
	char	szDomain[50+1];		/* domain(IP)	*/
	char	szHtmlFileName[100+1];	/* html file	*/
} DB;

#define	DB_SIZE		(sizeof(DB))


/*
** Prototype for MyUtil.c
*/
#ifdef __cplusplus
extern "C" {
#endif 

void getword		(char *word, char *line, char stop);
char *makeword		(char *line, char stop);
char *fmakeword		(FILE *f, char stop, int *cl);
char x2c		(char *what);
void unescape_url	(char *url);
void plustospace	(char *str);
int rind		(char *s, char c);
int getline		(char *s, int n, FILE *f);
void send_fd		(FILE *f, FILE *fd);
int ind			(char *s, char c);
void escape_shell_cmd	(char *cmd);
int  GetID		(void);

int	EatWs		(FILE *fpt);
int	CfgGetLine	(char *str, int n, FILE *fpt);
void	CfgGetWord	(char *word, char *line);

#ifdef __cplusplus
}
#endif

#endif	/* __MyCgi_h_	*/
