/*
	mSQL.cpp

	Author	: Kang Jul Ki (Master 2nd)
	E-mail	: jkkang@sel.chonbuk.ac.kr
	Homepage: http://sel.chonbuk.ac.kr/~jkkang/
	Date	: September 3, 1997
	Class	: Software Engineering Lab.
		  Dept. of Electronic Engineering
		  Chonbuk National Univ.	

	Compiler: gcc 2.7.2
	Copyright (c) 1997, Kang Jul Ki & Software Engineering Lab
*/

#include "mSQL.h"

mSQL::mSQL()
{
	m_iNumField = 0;
	m_iNumRow   = 0;
	m_Result    = NULL;
}

mSQL::~mSQL()
{
}

void mSQL::mSQLConnect(char *str)
{
	/*
	** DB Name
	*/
	strcpy(m_szDbName, str);

	/*
	** Connect of the mSQL Server
	*/
	if ((m_iSocket = msqlConnect(NULL)) == -1)
	{
		printf("Can't connect to mSQL Server...%c", LF);
		exit(1);
	}
}

void mSQL::mSQLSelectDB(void)
{
	/*
	** Select Database
	*/
	if (msqlSelectDB(m_iSocket, mSQLGetDbName()) == -1)
	{
		printf("Can't select %s...%c", mSQLGetDbName(), LF);
		msqlClose(m_iSocket);
		exit(1);
	}
}

void mSQL::mSQLQuery(void)
{
	if (msqlQuery(m_iSocket, m_szQuery) == -1)
	{
		printf("Can't to process query : %s%c", m_szQuery, LF);
		msqlClose(m_iSocket);
		exit(1);
	}
}

void mSQL::mSQLClose(void)
{
	/*
	** Free table memory of query result...
	*/
/*
	if (m_Result != NULL)
	{
		msqlFreeResult(m_Result);
	}
*/

	/*
	** Close Database Server
	*/
	msqlClose(m_iSocket);
}
